package com.ruoyi.common.security.utils;

import java.util.Collection;
import java.util.List;
import com.ruoyi.common.core.constant.Constants;
import com.ruoyi.common.core.utils.SpringUtils;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.redis.service.RedisService;
import com.ruoyi.system.api.domain.SysDictData;
import org.apache.commons.collections4.CollectionUtils;

/**
 * 字典工具类
 * 
 * @author ruoyi
 */
public class DictUtils
{
    /**
     * 设置字典缓存
     * 
     * @param key 参数键
     * @param dictDatas 字典数据列表
     */
    public static void setDictCache(String key, List<SysDictData> dictDatas)
    {
        SpringUtils.getBean(RedisService.class).setCacheObject(getCacheKey(key), dictDatas);
    }

    /**
     * 获取字典缓存
     * 
     * @param key 参数键
     * @return dictDatas 字典数据列表
     */
    public static List<SysDictData> getDictCache(String key)
    {
        Object cacheObj = SpringUtils.getBean(RedisService.class).getCacheObject(getCacheKey(key));
        if (StringUtils.isNotNull(cacheObj))
        {
            return StringUtils.cast(cacheObj);
        }
        return null;
    }

    /**
     * 删除指定字典缓存
     * 
     * @param key 字典键
     */
    public static void removeDictCache(String key)
    {
        SpringUtils.getBean(RedisService.class).deleteObject(getCacheKey(key));
    }

    /**
     * 清空字典缓存
     */
    public static void clearDictCache()
    {
        Collection<String> keys = SpringUtils.getBean(RedisService.class).keys(Constants.SYS_DICT_KEY + "*");
        SpringUtils.getBean(RedisService.class).deleteObject(keys);
    }

    /**
     * 设置cache key
     * 
     * @param configKey 参数键
     * @return 缓存键key
     */
    public static String getCacheKey(String configKey)
    {
        return Constants.SYS_DICT_KEY + configKey;
    }


    /**
     * 根据字典类型和字典值获取字典值
     * @Title getDictLabel
     * @author yuyehong@cloudwalk.cn
     * @date 16:10 2020/6/23
     * @param dictType 字典类型
     * @param dictValue 字典值
     * @param defaultLabel 默认值
     * @return java.lang.String
     */
    public static String getDictLabel(String dictType, String dictValue, String defaultLabel) {
        if (StringUtils.isNotBlank(dictType) && StringUtils.isNotBlank(dictValue)) {
            List<SysDictData> dictDataList = getDictCache(dictType);
            if (CollectionUtils.isNotEmpty(dictDataList)) {
                for (SysDictData dict : dictDataList) {
                    if (dictValue.equals(dict.getDictValue())) {
                        return dict.getDictLabel();
                    }
                }
            }
        }
        return defaultLabel;
    }
    /**
     * 根据字典类型和字典标签获取字典值
     * @Title getDictValue
     * @author yuyehong
     * @date 17:59 2020/6/23
     * @param dictType 字典类型
     * @param dictLabel 字典标签
     * @param defaultValue 默认值
     * @return java.lang.String
     */
    public static String getDictValue(String dictType, String dictLabel, String defaultValue) {
        if (StringUtils.isNotBlank(dictType) && StringUtils.isNotBlank(dictLabel)) {
            List<SysDictData> dictDataList = getDictCache(dictType);
            if (CollectionUtils.isNotEmpty(dictDataList)) {
                for (SysDictData dict : dictDataList) {
                    if (dictLabel.equals(dict.getDictLabel())) {
                        return dict.getDictValue();
                    }
                }
            }
        }
        return defaultValue;
    }
}
